import logger from "./inc/log";
import _fs from "fs";
import { read, cfg } from "./inc/cfg";
import { default as config } from "../cfg/config.json";
import cuffeo from "cuffeo";

const fs = _fs.promises;
const timeout = 1000;

(async () => {
  await read(); // read and parse config from database

  const self = {
    _trigger: new Map(),
    trigger: function trigger(args) {
      this.call = args.call;
      this.help = args.help || false;
      this.level = args.level || 0;
      this.active = args.hasOwnProperty("active") ? args.active : true;
      this.set = args.set || "all"; // uwe, nxy, f0ck, all
      this.clients = args.clients || [ "irc", "tg" ];
      this.f = args.f;
    },
    bot: new cuffeo(config.clients)
  };

  console.time("loading");
  const modules = {
    events:  (await  fs.readdir("./src/inc/events")).filter(f => f.endsWith(".mjs")),
    trigger: (await fs.readdir("./src/inc/trigger")).filter(f => f.endsWith(".mjs"))
  };

  console.timeLog("loading", "directories");

  const blah = (await Promise.all(Object.entries(modules).map(async ([dir, mods]) => ({
    [dir]: (await Promise.all(mods.map(async mod => {
      const res = await Promise.race([
        (await import(`./inc/${dir}/${mod}`)).default(self),
        new Promise((_, rej) => setTimeout(() => rej(false), timeout))
      ]);
      console.timeLog("loading", `${dir}/${mod}`);
      return res;
    }))).flat(2)
  })))).reduce((a, b) => ({...a, ...b}));

  blah.events.forEach(event => {
    console.timeLog("loading", `registering event > ${event.name}`);
    self.bot.on(event.listener, event.f);
  });

  blah.trigger.forEach(trigger => {
    console.timeLog("loading", `registering trigger > ${trigger.name}`);
    self._trigger.set(trigger.name, new self.trigger(trigger));
  });

  console.timeEnd("loading");

})();
